from enum import Enum


class RSCPTag(Enum):
    SERVER_REGISTER_CONNECTION = 0xF800A001
    SERVER_CONNECTION_ID = 0xF800B001
    SERVER_AUTH_LEVEL = 0xF800B002
    SERVER_STATUS = 0xF800B003
    SERVER_TYPE = 0xF800B006
    SERVER_HASH_CODE = 0xF800B007
    SERVER_CONNECTION_REGISTERED = 0xF808A001
    SERVER_UNREGISTER_CONNECTION = 0xF800A002
    SERVER_CONNECTION_UNREGISTERED = 0xF808A002
    SERVER_PING = 0xF808A004
    SERVER_REQ_PING = 0xF800A004
    SERVER_RSCP_DATA_LEN = 0xf800b004
    SERVER_RSCP_DATA = 0xf800b005
    SERVER_REQ_RSCP_CMD = 0xF800A003
    SERVER_RSCP_CMD_RESP = 0xF808A003
    SERVER_REQ_NEW_VIRTUAL_CONNECTION = 0xF800A005
    SERVER_USER = 0xF800B008
    SERVER_PASSWD = 0xF800B009
    SERVER_IDENTIFIER = 0xF800B010

    RSCP_REQ_AUTHENTICATION = 0x00000001
    RSCP_AUTHENTICATION_USER = 0x00000002
    RSCP_AUTHENTICATION_PASSWORD = 0x00000003
    RSCP_AUTHENTICATION = 0x00800001
    RSCP_REQ_USER_LEVEL = 0x00000004
    RSCP_USER_LEVEL = 0x00800004
    RSCP_REQ_SET_ENCRYPTION_PASSPHRASE = 0x00000005
    RSCP_SET_ENCRYPTION_PASSPHRASE = 0x00800005
    RSCP_GENERAL_ERROR = 0x00FFFFFF

    EMS_REQ_POWER_PV = 0x01000001
    EMS_REQ_POWER_BAT = 0x01000002
    EMS_REQ_POWER_HOME = 0x01000003
    EMS_REQ_POWER_GRID = 0x01000004
    EMS_REQ_POWER_ADD = 0x01000005
    EMS_REQ_AUTARKY = 0x01000006
    EMS_REQ_SELF_CONSUMPTION = 0x01000007
    EMS_REQ_BAT_SOC = 0x01000008
    EMS_REQ_COUPLING_MODE = 0x01000009
    EMS_REQ_STORED_ERRORS = 0x0100000A
    EMS_REQ_MODE = 0x01000011
    EMS_REQ_BALANCED_PHASES = 0x01000012
    EMS_REQ_INSTALLED_PEAK_POWER = 0x01000013
    EMS_REQ_DERATE_AT_PERCENT_VALUE = 0x01000014
    EMS_REQ_DERATE_AT_POWER_VALUE = 0x01000015
    EMS_REQ_ERROR_BUZZER_ENABLED = 0x01000016
    EMS_REQ_SET_BALANCED_PHASES = 0x01000017
    EMS_REQ_SET_INSTALLED_PEAK_POWER = 0x01000018
    EMS_REQ_SET_DERATE_PERCENT = 0x01000019
    EMS_REQ_SET_ERROR_BUZZER_ENABLED = 0x0100001A
    EMS_REQ_START_ADJUST_BATTERY_VOLTAGE = 0x0100001B
    EMS_REQ_CANCEL_ADJUST_BATTERY_VOLTAGE = 0x0100001C
    EMS_REQ_ADJUST_BATTERY_VOLTAGE_STATUS = 0x0100001D
    EMS_REQ_CONFIRM_ERRORS = 0x0100001E
    EMS_REQ_POWER_WB_ALL = 0x0100001F
    EMS_REQ_POWER_WB_SOLAR = 0x01000020
    EMS_REQ_EXT_SRC_AVAILABLE = 0x01000021

    EMS_POWER_PV = 0x01800001
    EMS_POWER_BAT = 0x01800002
    EMS_POWER_HOME = 0x01800003
    EMS_POWER_GRID = 0x01800004
    EMS_POWER_ADD = 0x01800005
    EMS_AUTARKY = 0x01800006
    EMS_SELF_CONSUMPTION = 0x01800007
    EMS_BAT_SOC = 0x01800008
    EMS_COUPLING_MODE = 0x01800009
    EMS_STORED_ERRORS = 0x0180000A
    EMS_ERROR_CONTAINER = 0x0180000B
    EMS_ERROR_TYPE = 0x0180000C
    EMS_ERROR_SOURCE = 0x0180000D
    EMS_ERROR_MESSAGE = 0x0180000E
    EMS_ERROR_CODE = 0x0180000F
    EMS_ERROR_TIMESTAMP = 0x01800010
    EMS_MODE = 0x01800011
    EMS_BALANCED_PHASES = 0x01800012
    EMS_INSTALLED_PEAK_POWER = 0x01800013
    EMS_DERATE_AT_PERCENT_VALUE = 0x01800014
    EMS_DERATE_AT_POWER_VALUE = 0x01800015
    EMS_ERROR_BUZZER_ENABLED = 0x01800016
    EMS_SET_BALANCED_PHASES = 0x01800017
    EMS_SET_INSTALLED_PEAK_POWER = 0x01800018
    EMS_SET_DERATE_PERCENT = 0x01800019
    EMS_SET_ERROR_BUZZER_ENABLED = 0x0180001A
    EMS_START_ADJUST_BATTERY_VOLTAGE = 0x0180001B
    EMS_CANCEL_ADJUST_BATTERY_VOLTAGE = 0x0180001C
    EMS_ADJUST_BATTERY_VOLTAGE_STATUS = 0x0180001D
    EMS_CONFIRM_ERRORS = 0x0180001E
    EMS_POWER_WB_ALL = 0x0180001F
    EMS_POWER_WB_SOLAR = 0x01800020
    EMS_EXT_SRC_AVAILABLE = 0x01800021

    EMS_REQ_SET_POWER = 0x01000030
    EMS_REQ_SET_POWER_MODE = 0x01000031
    EMS_REQ_SET_POWER_VALUE = 0x01000032
    EMS_SET_POWER = 0x01800030
    EMS_REQ_STATUS = 0x01000040
    EMS_STATUS = 0x01800040
    EMS_REQ_USED_CHARGE_LIMIT = 0x01000041
    EMS_REQ_BAT_CHARGE_LIMIT = 0x01000042
    EMS_REQ_DCDC_CHARGE_LIMIT = 0x01000043
    EMS_REQ_USER_CHARGE_LIMIT = 0x01000044
    EMS_REQ_USED_DISCHARGE_LIMIT = 0x01000045
    EMS_REQ_BAT_DISCHARGE_LIMIT = 0x01000046
    EMS_REQ_DCDC_DISCHARGE_LIMIT = 0x01000047
    EMS_REQ_USER_DISCHARGE_LIMIT = 0x01000048
    EMS_USED_CHARGE_LIMIT = 0x01800041
    EMS_BAT_CHARGE_LIMIT = 0x01800042
    EMS_DCDC_CHARGE_LIMIT = 0x01800043
    EMS_USER_CHARGE_LIMIT = 0x01800044
    EMS_USED_DISCHARGE_LIMIT = 0x01800045
    EMS_BAT_DISCHARGE_LIMIT = 0x01800046
    EMS_DCDC_DISCHARGE_LIMIT = 0x01800047
    EMS_USER_DISCHARGE_LIMIT = 0x01800048
    EMS_REQ_SET_POWER_CONTROL_OFFSET = 0x01000060
    EMS_SET_POWER_CONTROL_OFFSET = 0x01800060
    EMS_REQ_REMAINING_BAT_CHARGE_POWER = 0x01000071
    EMS_REMAINING_BAT_CHARGE_POWER = 0x01800071
    EMS_REQ_REMAINING_BAT_DISCHARGE_POWER = 0x01000072
    EMS_REMAINING_BAT_DISCHARGE_POWER = 0x01800072
    EMS_REQ_EMERGENCY_POWER_STATUS = 0x01000073
    EMS_EMERGENCY_POWER_STATUS = 0x01800073
    EMS_REQ_SET_EMERGENCY_POWER = 0x01000074
    EMS_SET_EMERGENCY_POWER = 0x01800074
    EMS_REQ_SET_OVERRIDE_AVAILABLE_POWER = 0x01000075
    EMS_SET_OVERRIDE_AVAILABLE_POWER = 0x01800075

    EMS_SET_BATTERY_TO_CAR_MODE = 0x01800076
    EMS_REQ_SET_BATTERY_TO_CAR_MODE = 0x01000076
    EMS_BATTERY_TO_CAR_MODE = 0x01800077
    EMS_REQ_BATTERY_TO_CAR_MODE = 0x01000077
    EMS_SET_BATTERY_BEFORE_CAR_MODE = 0x01800078
    EMS_REQ_SET_BATTERY_BEFORE_CAR_MODE = 0x01000078
    EMS_BATTERY_BEFORE_CAR_MODE = 0x01800079
    EMS_REQ_BATTERY_BEFORE_CAR_MODE = 0x01000079

    EMS_REQ_GET_IDLE_PERIODS = 0x01000080
    EMS_GET_IDLE_PERIODS = 0x01800080
    EMS_REQ_SET_IDLE_PERIODS = 0x01000081
    EMS_SET_IDLE_PERIODS = 0x01800081
    EMS_IDLE_PERIOD = 0x01000082
    EMS_IDLE_PERIOD_TYPE = 0x01000083
    EMS_IDLE_PERIOD_DAY = 0x01000084
    EMS_IDLE_PERIOD_START = 0x01000085
    EMS_IDLE_PERIOD_END = 0x01000086
    EMS_IDLE_PERIOD_HOUR = 0x01000087
    EMS_IDLE_PERIOD_MINUTE = 0x01000088
    EMS_IDLE_PERIOD_ACTIVE = 0x01000089
    EMS_REQ_IDLE_PERIOD_CHANGE_MARKER = 0x0100008A
    EMS_IDLE_PERIOD_CHANGE_MARKER = 0x0180008A

    EMS_REQ_GET_POWER_SETTINGS = 0x0100008B
    EMS_GET_POWER_SETTINGS = 0x0180008B
    EMS_REQ_SET_POWER_SETTINGS = 0x0100008C
    EMS_SET_POWER_SETTINGS = 0x0180008C
    EMS_POWER_LIMITS_USED = 0x01000100
    EMS_RES_POWER_LIMITS_USED = 0x01800100
    EMS_MAX_CHARGE_POWER = 0x01000101
    EMS_RES_MAX_CHARGE_POWER = 0x01800101
    EMS_MAX_DISCHARGE_POWER = 0x01000102
    EMS_RES_MAX_DISCHARGE_POWER = 0x01800102
    EMS_DISCHARGE_START_POWER = 0x01000103
    EMS_RES_DISCHARGE_START_POWER = 0x01800103
    EMS_POWERSAVE_ENABLED = 0x01000104
    EMS_RES_POWERSAVE_ENABLED = 0x01800104
    EMS_WEATHER_REGULATED_CHARGE_ENABLED = 0x01000105
    EMS_RES_WEATHER_REGULATED_CHARGE_ENABLED = 0x01800105

    EMS_REQ_SETTINGS_CHANGE_MARKER = 0x0100008D
    EMS_SETTINGS_CHANGE_MARKER = 0x0180008D

    EMS_REQ_GET_MANUAL_CHARGE = 0x0100008E
    EMS_GET_MANUAL_CHARGE = 0x0180008E
    EMS_MANUAL_CHARGE_START_COUNTER = 0x01000150
    EMS_MANUAL_CHARGE_ACTIVE = 0x01000151
    EMS_MANUAL_CHARGE_ENERGY_COUNTER = 0x01000152
    EMS_MANUAL_CHARGE_LASTSTART = 0x01000153
    EMS_REQ_START_MANUAL_CHARGE = 0x0100008F
    EMS_START_MANUAL_CHARGE = 0x0180008F

    EMS_REQ_START_EMERGENCYPOWER_TEST = 0x01000090
    EMS_START_EMERGENCYPOWER_TEST = 0x01800090

    EMS_REQ_GET_GENERATOR_STATE = 0x01000091
    EMS_GET_GENERATOR_STATE = 0x01800091
    EMS_REQ_SET_GENERATOR_MODE = 0x01000092
    EMS_SET_GENERATOR_MODE = 0x01800092

    EMS_REQ_EMERGENCYPOWER_TEST_STATUS = 0x01000093
    EMS_EMERGENCYPOWER_TEST_STATUS = 0x01800093
    EMS_EPTEST_NEXT_TESTSTART = 0x01000094
    EMS_EPTEST_START_COUNTER = 0x01000095
    EMS_EPTEST_RUNNING = 0x01000096

    EMS_REQ_GET_SYS_SPECS = 0x01000097
    EMS_GET_SYS_SPECS = 0x01800098
    EMS_SYS_SPEC = 0x01000099
    EMS_SYS_SPEC_INDEX = 0x0100009A
    EMS_SYS_SPEC_NAME = 0x0100009B
    EMS_SYS_SPEC_VALUE_INT = 0x0100009C
    EMS_SYS_SPEC_VALUE_STRING = 0x0100009D

    EMS_REQ_ALIVE = 0x01050000
    EMS_ALIVE = 0x01850000
    EMS_GENERAL_ERROR = 0x01FFFFFF

    BAT_REQ_DATA = 0x03040000
    BAT_INDEX = 0x03040001
    BAT_DATA = 0x03840000
    BAT_RSOC = 0x03800001
    BAT_MODULE_VOLTAGE = 0x03800002
    BAT_CURRENT = 0x03800003
    BAT_MAX_BAT_VOLTAGE = 0x03800004
    BAT_MAX_CHARGE_CURRENT = 0x03800005
    BAT_EOD_VOLTAGE = 0x03800006
    BAT_MAX_DISCHARGE_CURRENT = 0x03800007
    BAT_CHARGE_CYCLES = 0x03800008
    BAT_TERMINAL_VOLTAGE = 0x03800009
    BAT_STATUS_CODE = 0x0380000A
    BAT_ERROR_CODE = 0x0380000B
    BAT_DEVICE_NAME = 0x0380000C
    BAT_DCB_COUNT = 0x0380000D
    BAT_RSOC_REAL = 0x0380000E
    BAT_ASOC = 0x0380000F
    BAT_FCC = 0x03800010
    BAT_RC = 0x03800011
    BAT_MAX_DCB_CELL_CURRENT = 0x03800012
    BAT_MIN_DCB_CELL_CURRENT = 0x03800013
    BAT_MAX_DCB_CELL_VOLTAGE = 0x03800014
    BAT_MIN_DCB_CELL_VOLTAGE = 0x03800015
    BAT_MAX_DCB_CELL_TEMPERATURE = 0x03800016
    BAT_MIN_DCB_CELL_TEMPERATURE = 0x03800017
    BAT_DCB_ALL_CELL_TEMPERATURES = 0x03800018
    BAT_DCB_CELL_TEMPERATURE = 0x03800019
    BAT_DCB_ALL_CELL_VOLTAGES = 0x0380001A
    BAT_DCB_CELL_VOLTAGE = 0x0380001B
    BAT_OPEN_BREAKER = 0x0380001C
    BAT_OPEN_BREAKER_CONFIRM = 0x0380001D
    BAT_READY_FOR_SHUTDOWN = 0x0380001E
    BAT_FIRMWARE_VERSION = 0x0380001F
    BAT_TIME_LAST_RESPONSE = 0x03800024
    BAT_MANUFACTURER_NAME = 0x03800025
    BAT_USABLE_CAPACITY = 0x03800026
    BAT_USABLE_REMAINING_CAPACITY = 0x03800027
    BAT_INFO = 0x03800020
    BAT_TRAINING_MODE = 0x03800021
    BAT_UPDATE_STATUS = 0x03800022
    BAT_SET_A1_DATA = 0x03800028
    BAT_CONTROL_CODE = 0x03800032
    BAT_REQ_RSOC = 0x03000001
    BAT_REQ_MODULE_VOLTAGE = 0x03000002
    BAT_REQ_CURRENT = 0x03000003
    BAT_REQ_MAX_BAT_VOLTAGE = 0x03000004
    BAT_REQ_MAX_CHARGE_CURRENT = 0x03000005
    BAT_REQ_EOD_VOLTAGE = 0x03000006
    BAT_REQ_MAX_DISCHARGE_CURRENT = 0x03000007
    BAT_REQ_CHARGE_CYCLES = 0x03000008
    BAT_REQ_TERMINAL_VOLTAGE = 0x03000009
    BAT_REQ_STATUS_CODE = 0x0300000A
    BAT_REQ_ERROR_CODE = 0x0300000B
    BAT_REQ_DEVICE_NAME = 0x0300000C
    BAT_REQ_DCB_COUNT = 0x0300000D
    BAT_REQ_RSOC_REAL = 0x0300000E
    BAT_REQ_ASOC = 0x0300000F
    BAT_REQ_FCC = 0x03000010
    BAT_REQ_RC = 0x03000011
    BAT_REQ_MAX_DCB_CELL_CURRENT = 0x03000012
    BAT_REQ_MIN_DCB_CELL_CURRENT = 0x03000013
    BAT_REQ_MAX_DCB_CELL_VOLTAGE = 0x03000014
    BAT_REQ_MIN_DCB_CELL_VOLTAGE = 0x03000015
    BAT_REQ_MAX_DCB_CELL_TEMPERATURE = 0x03000016
    BAT_REQ_MIN_DCB_CELL_TEMPERATURE = 0x03000017
    BAT_REQ_DCB_ALL_CELL_TEMPERATURES = 0x03000018
    BAT_REQ_DCB_ALL_CELL_VOLTAGES = 0x0300001A
    BAT_REQ_OPEN_BREAKER = 0x0300001C
    BAT_REQ_OPEN_BREAKER_CONFIRM = 0x0300001D
    BAT_REQ_READY_FOR_SHUTDOWN = 0x0300001E
    BAT_REQ_FIRMWARE_VERSION = 0x0300001F
    BAT_REQ_INFO = 0x03000020
    BAT_REQ_TRAINING_MODE = 0x03000021
    BAT_REQ_UPDATE_STATUS = 0x03000022
    BAT_REQ_SET_TRAINING_MODE = 0x03000023
    BAT_REQ_TIME_LAST_RESPONSE = 0x03000024
    BAT_REQ_MANUFACTURER_NAME = 0x03000025
    BAT_REQ_USABLE_CAPACITY = 0x03000026
    BAT_REQ_USABLE_REMAINING_CAPACITY = 0x03000027
    BAT_REQ_SET_A1_DATA = 0x03000028
    BAT_REQ_SET_A1_MODE = 0x03000029
    BAT_REQ_SET_A1_VOLTAGE = 0x03000030
    BAT_REQ_SET_A1_CURRENT = 0x03000031
    BAT_REQ_CONTROL_CODE = 0x03000032
    BAT_REQ_DCB_INFO = 0x03000042
    BAT_DCB_INFO = 0x03800042
    BAT_DCB_INDEX = 0x03800100
    BAT_DCB_LAST_MESSAGE_TIMESTAMP = 0x03800101
    BAT_DCB_MAX_CHARGE_VOLTAGE = 0x03800102
    BAT_DCB_MAX_CHARGE_CURRENT = 0x03800103
    BAT_DCB_END_OF_DISCHARGE = 0x03800104
    BAT_DCB_MAX_DISCHARGE_CURRENT = 0x03800105
    BAT_DCB_FULL_CHARGE_CAPACITY = 0x03800106
    BAT_DCB_REMAINING_CAPACITY = 0x03800107
    BAT_DCB_SOC = 0x03800108
    BAT_DCB_SOH = 0x03800109
    BAT_DCB_CYCLE_COUNT = 0x03800110
    BAT_DCB_CURRENT = 0x03800111
    BAT_DCB_VOLTAGE = 0x03800112
    BAT_DCB_CURRENT_AVG_30S = 0x03800113
    BAT_DCB_VOLTAGE_AVG_30S = 0x03800114
    BAT_DCB_DESIGN_CAPACITY = 0x03800115
    BAT_DCB_DESIGN_VOLTAGE = 0x03800116
    BAT_DCB_CHARGE_LOW_TEMPERATURE = 0x03800117
    BAT_DCB_CHARGE_HIGH_TEMPERATURE = 0x03800118
    BAT_DCB_MANUFACTURE_DATE = 0x03800119
    BAT_DCB_SERIALNO = 0x03800120
    BAT_DCB_PROTOCOL_VERSION = 0x03800121
    BAT_DCB_FW_VERSION = 0x03800122
    BAT_DCB_DATA_TABLE_VERSION = 0x03800123
    BAT_DCB_PCB_VERSION = 0x03800124

    BAT_REQ_DEVICE_STATE = 0x03060000
    BAT_DEVICE_STATE = 0x03860000
    BAT_DEVICE_CONNECTED = 0x03860001
    BAT_DEVICE_WORKING = 0x03860002
    BAT_DEVICE_IN_SERVICE = 0x03860003
    BAT_GENERAL_ERROR = 0x03FFFFFF

    PM_REQ_DATA = 0x05040000
    PM_INDEX = 0x05040001
    PM_DATA = 0x05840000
    PM_REQ_POWER_L1 = 0x05000001
    PM_REQ_POWER_L2 = 0x05000002
    PM_REQ_POWER_L3 = 0x05000003
    PM_REQ_ACTIVE_PHASES = 0x05000004
    PM_REQ_MODE = 0x05000005
    PM_REQ_ENERGY_L1 = 0x05000006
    PM_REQ_ENERGY_L2 = 0x05000007
    PM_REQ_ENERGY_L3 = 0x05000008
    PM_REQ_DEVICE_ID = 0x05000009
    PM_REQ_ERROR_CODE = 0x0500000A
    PM_REQ_SET_PHASE_ELIMINATION = 0x0500000B
    PM_REQ_GET_PHASE_ELIMINATION = 0x05000018
    PM_REQ_FIRMWARE_VERSION = 0x0500000C
    PM_REQ_SET_FOR_EMERGENCY_TEST = 0x0500000D
    PM_REQ_IS_CAN_SILENCE = 0x0500000E

    PM_REQ_VOLTAGE_L1 = 0x05000011
    PM_REQ_VOLTAGE_L2 = 0x05000012
    PM_REQ_VOLTAGE_L3 = 0x05000013
    PM_REQ_TYPE = 0x05000014

    PM_POWER_L1 = 0x05800001
    PM_POWER_L2 = 0x05800002
    PM_POWER_L3 = 0x05800003
    PM_ACTIVE_PHASES = 0x05800004
    PM_MODE = 0x05800005
    PM_ENERGY_L1 = 0x05800006
    PM_ENERGY_L2 = 0x05800007
    PM_ENERGY_L3 = 0x05800008
    PM_DEVICE_ID = 0x05800009
    PM_ERROR_CODE = 0x0580000A
    PM_SET_PHASE_ELIMINATION = 0x0580000B
    PM_GET_PHASE_ELIMINATION = 0x05800018
    PM_FIRMWARE_VERSION = 0x0580000C
    PM_SET_FOR_EMERGENCY_TEST = 0x0580000D
    PM_IS_CAN_SILENCE = 0x0580000E

    PM_VOLTAGE_L1 = 0x05800011
    PM_VOLTAGE_L2 = 0x05800012
    PM_VOLTAGE_L3 = 0x05800013
    PM_TYPE = 0x05800014

    PM_REQ_COMM_STATE = 0x05000050
    PM_COMM_STATE = 0x05800050
    PM_CS_START_TIME = 0x05800051
    PM_CS_LAST_TIME = 0x05800052
    PM_CS_SUCC_FRAMES_ALL = 0x05800053
    PM_CS_SUCC_FRAMES_100 = 0x05800054
    PM_CS_EXP_FRAMES_ALL = 0x05800055
    PM_CS_EXP_FRAMES_100 = 0x05800056
    PM_CS_ERR_FRAMES_ALL = 0x05800057
    PM_CS_ERR_FRAMES_100 = 0x05800058
    PM_CS_UNK_FRAMES = 0x05800059
    PM_CS_ERR_FRAME = 0x0580005A

    PM_REQ_DEVICE_STATE = 0x05060000
    PM_DEVICE_STATE = 0x05860000
    PM_DEVICE_CONNECTED = 0x05860001
    PM_DEVICE_WORKING = 0x05860002
    PM_DEVICE_IN_SERVICE = 0x05860003
    PM_GENERAL_ERROR = 0x05FFFFFF

    DCDC_REQ_DATA = 0x04040000
    DCDC_INDEX = 0x04040001
    DCDC_DATA = 0x04840000
    DCDC_REQ_I_BAT = 0x04000001
    DCDC_REQ_U_BAT = 0x04000002
    DCDC_REQ_P_BAT = 0x04000003
    DCDC_REQ_I_DCL = 0x04000004
    DCDC_REQ_U_DCL = 0x04000005
    DCDC_REQ_P_DCL = 0x04000006
    DCDC_REQ_SELF_TEST = 0x04000007
    DCDC_REQ_FIRMWARE_VERSION = 0x04000008
    DCDC_REQ_FPGA_FIRMWARE = 0x04000009
    DCDC_REQ_SERIAL_NUMBER = 0x0400000A
    DCDC_REQ_BOARD_VERSION = 0x0400000B
    DCDC_REQ_FLASH_FILE_LIST = 0x0400000C
    DCDC_REQ_IS_FLASHING = 0x0400000E
    DCDC_REQ_FLASH = 0x0400000F
    DCDC_REQ_STATUS = 0x04000010
    DCDC_REQ_STATUS_AS_STRING = 0x04000013

    DCDC_I_BAT = 0x04800001
    DCDC_U_BAT = 0x04800002
    DCDC_P_BAT = 0x04800003
    DCDC_I_DCL = 0x04800004
    DCDC_U_DCL = 0x04800005
    DCDC_P_DCL = 0x04800006
    DCDC_SELF_TEST = 0x04800007
    DCDC_FIRMWARE_VERSION = 0x04800008
    DCDC_FPGA_FIRMWARE = 0x04800009
    DCDC_SERIAL_NUMBER = 0x0480000A
    DCDC_BOARD_VERSION = 0x0480000B
    DCDC_FLASH_FILE_LIST = 0x0480000C
    DCDC_FLASH_FILE = 0x0480000D
    DCDC_IS_FLASHING = 0x0480000E
    DCDC_FLASH = 0x0480000F
    DCDC_STATUS = 0x04800010
    DCDC_STATE = 0x04800011
    DCDC_SUBSTATE = 0x04800012
    DCDC_STATUS_AS_STRING = 0x04800013
    DCDC_STATE_AS_STRING = 0x04800014
    DCDC_SUBSTATE_AS_STRING = 0x04800015

    DCDC_REQ_DEVICE_STATE = 0x04060000
    DCDC_DEVICE_STATE = 0x04860000
    DCDC_DEVICE_CONNECTED = 0x04860001
    DCDC_DEVICE_WORKING = 0x04860002
    DCDC_DEVICE_IN_SERVICE = 0x04860003
    DCDC_GENERAL_ERROR = 0x04FFFFFF

    PVI_DATA = 0x02840000
    PVI_REQ_DATA = 0x02040000
    PVI_INDEX = 0x02040001

    PVI_VALUE = 0x02040005

    PVI_GENERAL_ERROR = 0x02FFFFFF

    PVI_ON_GRID = 0x02800001
    PVI_REQ_ON_GRID = 0x02000001
    PVI_STATE = 0x02800002
    PVI_REQ_STATE = 0x02000002
    PVI_LAST_ERROR = 0x02800003
    PVI_REQ_LAST_ERROR = 0x02000003
    PVI_IS_FLASHING = 0x02800004
    PVI_REQ_IS_FLASHING = 0x02000004
    PVI_REQ_START_FLASHING = 0x02000005
    PVI_FLASH_FILE_LIST = 0x02800006
    PVI_FLASH_FILE = 0x02800007
    PVI_REQ_FLASH_FILE_LIST = 0x02000006
    PVI_SERVICE_PROGRESS_STATE = 0x02800008
    PVI_REQ_SERVICE_PROGRESS_STATE = 0x02000008
    PVI_REQ_DEVICE_STATE = 0x02060000
    PVI_DEVICE_STATE = 0x02860000
    PVI_DEVICE_CONNECTED = 0x02860001
    PVI_DEVICE_WORKING = 0x02860002
    PVI_DEVICE_IN_SERVICE = 0x02860003
    PVI_REQ_TYPE = 0x02000009
    PVI_TYPE = 0x02800009

    PVI_UZK_VOLTAGE = 0x02800050
    PVI_REQ_UZK_VOLTAGE = 0x02000050
    PVI_COS_PHI = 0x02800060
    PVI_REQ_COS_PHI = 0x02000060
    PVI_REQ_SET_COS_PHI = 0x02000061
    PVI_COS_PHI_VALUE = 0x02000062
    PVI_COS_PHI_IS_AKTIV = 0x02000063
    PVI_COS_PHI_EXCITED = 0x02000064
    PVI_VOLTAGE_MONITORING = 0x02800070
    PVI_REQ_VOLTAGE_MONITORING = 0x02000070
    PVI_REQ_SET_VOLTAGE_MONITORING = 0x02000071
    PVI_VOLTAGE_MONITORING_THRESHOLD_TOP = 0x02000072
    PVI_VOLTAGE_MONITORING_THRESHOLD_BOTTOM = 0x02000073
    PVI_VOLTAGE_MONITORING_SLOPE_UP = 0x02000074
    PVI_VOLTAGE_MONITORING_SLOPE_DOWN = 0x02000075
    PVI_FREQUENCY_UNDER_OVER = 0x02800080
    PVI_REQ_FREQUENCY_UNDER_OVER = 0x02000080
    PVI_SET_FREQUENCY_UNDER_OVER = 0x02800081
    PVI_REQ_SET_FREQUENCY_UNDER_OVER = 0x02000081
    PVI_FREQUENCY_UNDER = 0x02000082
    PVI_FREQUENCY_OVER = 0x02000083
    PVI_SET_SYSTEM_MODE = 0x02800084
    PVI_REQ_SET_SYSTEM_MODE = 0x02000084
    PVI_SYSTEM_MODE = 0x02800085
    PVI_REQ_SYSTEM_MODE = 0x02000085
    PVI_SET_POWER_MODE = 0x02800086
    PVI_REQ_SET_POWER_MODE = 0x02000086
    PVI_POWER_MODE = 0x02800087
    PVI_REQ_POWER_MODE = 0x02000087

    PVI_TEMPERATURE = 0x02800100
    PVI_REQ_TEMPERATURE = 0x02000100
    PVI_TEMPERATURE_COUNT = 0x02800101
    PVI_REQ_TEMPERATURE_COUNT = 0x02000101
    PVI_MAX_TEMPERATURE = 0x02800102
    PVI_REQ_MAX_TEMPERATURE = 0x02000102
    PVI_MIN_TEMPERATURE = 0x02800103
    PVI_REQ_MIN_TEMPERATURE = 0x02000103

    PVI_SERIAL_NUMBER = 0x028ABC01
    PVI_REQ_SERIAL_NUMBER = 0x020ABC01
    PVI_VERSION = 0x028ABC02
    PVI_REQ_VERSION = 0x020ABC02
    PVI_VERSION_MAIN = 0x020ABC03
    PVI_VERSION_PIC = 0x020ABC04
    PVI_REQ_SET_RESET_GPIO = 0x020ABC50
    PVI_REQ_SET_POWEROFF_GPIO = 0x020ABC51
    PVI_REQ_SET_NIGHTSWITCH_GPIO = 0x020ABC52
    PVI_REQ_SET_PRE_GRID_CHARGE = 0x020ABC60

    PVI_AC_MAX_PHASE_COUNT = 0x028AC000
    PVI_AC_POWER = 0x028AC001
    PVI_AC_VOLTAGE = 0x028AC002
    PVI_AC_CURRENT = 0x028AC003
    PVI_AC_APPARENTPOWER = 0x028AC004
    PVI_AC_REACTIVEPOWER = 0x028AC005
    PVI_AC_ENERGY_ALL = 0x028AC006
    PVI_AC_MAX_APPARENTPOWER = 0x028AC007
    PVI_AC_ENERGY_DAY = 0x028AC008
    PVI_AC_ENERGY_GRID_CONSUMPTION = 0x028AC009

    PVI_REQ_AC_MAX_PHASE_COUNT = 0x020AC000
    PVI_REQ_AC_POWER = 0x020AC001
    PVI_REQ_AC_VOLTAGE = 0x020AC002
    PVI_REQ_AC_CURRENT = 0x020AC003
    PVI_REQ_AC_APPARENTPOWER = 0x020AC004
    PVI_REQ_AC_REACTIVEPOWER = 0x020AC005
    PVI_REQ_AC_ENERGY_ALL = 0x020AC006
    PVI_REQ_AC_MAX_APPARENTPOWER = 0x020AC007
    PVI_REQ_AC_ENERGY_DAY = 0x020AC008
    PVI_REQ_AC_ENERGY_GRID_CONSUMPTION = 0x020AC009

    PVI_DC_MAX_STRING_COUNT = 0x028DC000
    PVI_DC_POWER = 0x028DC001
    PVI_DC_VOLTAGE = 0x028DC002
    PVI_DC_CURRENT = 0x028DC003
    PVI_DC_MAX_POWER = 0x028DC004
    PVI_DC_MAX_VOLTAGE = 0x028DC005
    PVI_DC_MIN_VOLTAGE = 0x028DC006
    PVI_DC_MAX_CURRENT = 0x028DC007
    PVI_DC_MIN_CURRENT = 0x028DC008
    PVI_DC_STRING_ENERGY_ALL = 0x028DC009

    PVI_REQ_DC_MAX_STRING_COUNT = 0x020DC000
    PVI_REQ_DC_POWER = 0x020DC001
    PVI_REQ_DC_VOLTAGE = 0x020DC002
    PVI_REQ_DC_CURRENT = 0x020DC003
    PVI_REQ_DC_MAX_POWER = 0x020DC004
    PVI_REQ_DC_MAX_VOLTAGE = 0x020DC005
    PVI_REQ_DC_MIN_VOLTAGE = 0x020DC006
    PVI_REQ_DC_MAX_CURRENT = 0x020DC007
    PVI_REQ_DC_MIN_CURRENT = 0x020DC008
    PVI_REQ_DC_STRING_ENERGY_ALL = 0x020DC009

    HA_REQ_DATAPOINT_LIST = 0x09000001
    HA_REQ_ACTUATOR_STATES = 0x09000010
    HA_REQ_ADD_ACTUATOR = 0x09000020
    HA_REQ_REMOVE_ACTUATOR = 0x09000030
    HA_REQ_COMMAND_ACTUATOR = 0x09000040
    HA_REQ_COMMAND = 0x09000041
    HA_REQ_DESCRIPTIONS_CHANGE = 0x09000050
    HA_REQ_CONFIGURATION_CHANGE_COUNTER = 0x09000060
    HA_CONFIGURATION_CHANGE_COUNTER = 0x09800060

    HA_DATAPOINT_LIST = 0x09800001
    HA_DATAPOINT = 0x09800002
    HA_DATAPOINT_INDEX = 0x09800003
    HA_DATAPOINT_TYPE = 0x09800004
    HA_DATAPOINT_NAME = 0x09800005
    HA_DATAPOINT_STATE = 0x09800011
    HA_DATAPOINT_STATE_TIMESTAMP = 0x09800013
    HA_DATAPOINT_STATE_VALUE = 0x09800014
    HA_DATAPOINT_SUPPLY_QUALITY = 0x09800015
    HA_DATAPOINT_SIGNAL_QUALITY = 0x09800016
    HA_DATAPOINT_MODE = 0x09800012
    HA_DATAPOINT_DESCRIPTIONS = 0x09800006
    HA_DATAPOINT_DESCRIPTION = 0x09800007
    HA_DATAPOINT_DESCRIPTION_NAME = 0x09800008
    HA_DATAPOINT_DESCRIPTION_VALUE = 0x09800009
    HA_ACTUATOR_STATES = 0x09800010
    HA_ADD_ACTUATOR = 0x09800020
    HA_REMOVE_ACTUATOR = 0x09800030
    HA_COMMAND_ACTUATOR = 0x09800040
    HA_DESCRIPTIONS_CHANGE = 0x09800050
    HA_REQ_DEVICE_STATE = 0x09060000
    HA_DEVICE_STATE = 0x09860000
    HA_DEVICE_CONNECTED = 0x09860001
    HA_DEVICE_WORKING = 0x09860002
    HA_DEVICE_IN_SERVICE = 0x09860003
    HA_GENERAL_ERROR = 0x09FFFFFF

    SRV_REQ_IS_ONLINE = 0x08000001
    SRV_IS_ONLINE = 0x08800001
    SRV_REQ_ADD_USER = 0x08000002
    SRV_ADD_USER = 0x08800002

    SRV_GENERAL_ERROR = 0x08FFFFFF

    INFO_REQ_SERIAL_NUMBER = 0x0A000001
    INFO_REQ_PRODUCTION_DATE = 0x0A000002
    INFO_REQ_MODULES_SW_VERSIONS = 0x0A000003
    INFO_REQ_A35_SERIAL_NUMBER = 0x0A000007
    INFO_REQ_IP_ADDRESS = 0x0A000008
    INFO_REQ_SUBNET_MASK = 0x0A000009
    INFO_REQ_MAC_ADDRESS = 0x0A00000A
    INFO_REQ_GATEWAY = 0x0A00000B
    INFO_REQ_DNS = 0x0A00000C
    INFO_REQ_DHCP_STATUS = 0x0A00000D
    INFO_REQ_TIME = 0x0A00000E
    INFO_REQ_UTC_TIME = 0x0A00000F
    INFO_REQ_TIME_ZONE = 0x0A000010
    INFO_REQ_INFO = 0x0A000011
    INFO_REQ_SET_IP_ADDRESS = 0x0A000012
    INFO_REQ_SET_SUBNET_MASK = 0x0A000013
    INFO_REQ_SET_DHCP_STATUS = 0x0A000014
    INFO_REQ_SET_GATEWAY = 0x0A000015
    INFO_REQ_SET_DNS = 0x0A000016
    INFO_REQ_SET_TIME_ZONE = 0x0A000018
    INFO_REQ_SW_RELEASE = 0x0A000019

    INFO_SERIAL_NUMBER = 0x0A800001
    INFO_PRODUCTION_DATE = 0x0A800002
    INFO_MODULES_SW_VERSIONS = 0x0A800003
    INFO_MODULE_SW_VERSION = 0x0A800004
    INFO_MODULE = 0x0A800005
    INFO_VERSION = 0x0A800006
    INFO_A35_SERIAL_NUMBER = 0x0A800007
    INFO_IP_ADDRESS = 0x0A800008
    INFO_SUBNET_MASK = 0x0A800009
    INFO_MAC_ADDRESS = 0x0A80000A
    INFO_GATEWAY = 0x0A80000B
    INFO_DNS = 0x0A80000C
    INFO_DHCP_STATUS = 0x0A80000D
    INFO_TIME = 0x0A80000E
    INFO_UTC_TIME = 0x0A80000F
    INFO_TIME_ZONE = 0x0A800010
    INFO_INFO = 0x0A800011
    INFO_SET_IP_ADDRESS = 0x0A800012
    INFO_SET_SUBNET_MASK = 0x0A800013
    INFO_SET_DHCP_STATUS = 0x0A800014
    INFO_SET_GATEWAY = 0x0A800015
    INFO_SET_DNS = 0x0A800016
    INFO_SET_TIME = 0x0A800017
    INFO_SET_TIME_ZONE = 0x0A800018
    INFO_SW_RELEASE = 0x0A800019

    INFO_GENERAL_ERROR = 0x0AFFFFFF

    EP_REQ_SWITCH_TO_GRID = 0x0B000001
    EP_REQ_SWITCH_TO_ISLAND = 0x0B000002
    EP_REQ_IS_READY_FOR_SWITCH = 0x0B000003
    EP_REQ_IS_GRID_CONNECTED = 0x0B000004
    EP_REQ_IS_ISLAND_GRID = 0x0B000005
    EP_REQ_IS_INVALID_STATE = 0x0B000006
    EP_REQ_IS_POSSIBLE = 0x0B000007
    EP_REQ_LEAVE_INVALID_STATE_TO_ISLAND = 0x0B000008
    EP_REQ_LEAVE_INVALID_STATE_TO_GRID = 0x0B000009

    EP_SWITCH_TO_GRID = 0x0B800001
    EP_SWITCH_TO_ISLAND = 0x0B800002
    EP_IS_READY_FOR_SWITCH = 0x0B800003
    EP_IS_GRID_CONNECTED = 0x0B800004
    EP_IS_ISLAND_GRID = 0x0B800005
    EP_IS_INVALID_STATE = 0x0B800006
    EP_IS_POSSIBLE = 0x0B800007
    EP_LEAVE_INVALID_STATE_TO_ISLAND = 0x0B800008
    EP_LEAVE_INVALID_STATE_TO_GRID = 0x0B800009

    EP_GENERAL_ERROR = 0x0BFFFFFF

    DB_REQ_HISTORY_DATA_DAY = 0x06000100
    DB_REQ_HISTORY_TIME_START = 0x06000101
    DB_REQ_HISTORY_TIME_INTERVAL = 0x06000102
    DB_REQ_HISTORY_TIME_SPAN = 0x06000103
    DB_REQ_HISTORY_DATA_WEEK = 0x06000200
    DB_REQ_HISTORY_DATA_MONTH = 0x06000300
    DB_REQ_HISTORY_DATA_YEAR = 0x06000400

    DB_SUM_CONTAINER = 0x06800010
    DB_VALUE_CONTAINER = 0x06800020
    DB_GRAPH_INDEX = 0x06800001
    DB_BAT_POWER_IN = 0x06800002
    DB_BAT_POWER_OUT = 0x06800003
    DB_DC_POWER = 0x06800004
    DB_GRID_POWER_IN = 0x06800005
    DB_GRID_POWER_OUT = 0x06800006
    DB_CONSUMPTION = 0x06800007
    DB_PM_0_POWER = 0x06800008
    DB_PM_1_POWER = 0x06800009
    DB_BAT_CHARGE_LEVEL = 0x0680000A
    DB_BAT_CYCLE_COUNT = 0x0680000B
    DB_CONSUMED_PRODUCTION = 0x0680000C
    DB_AUTARKY = 0x0680000D

    DB_HISTORY_DATA_DAY = 0x06800100
    DB_HISTORY_DATA_WEEK = 0x06800200
    DB_HISTORY_DATA_MONTH = 0x06800300
    DB_HISTORY_DATA_YEAR = 0x06800400

    DB_REQ_SYNC_HIST = 0x06000500
    DB_SYNC_HIST = 0x06800500
    DB_REQ_VACUUM_HIST = 0x06000501
    DB_VACUUM_HIST = 0x06800501
    DB_REQ_SYNC_BPU = 0x06000502
    DB_SYNC_BPU = 0x06800502
    DB_REQ_VACUUM_BPU = 0x06000503
    DB_VACUUM_BPU = 0x06800503
    DB_REQ_SYNC_DCB = 0x06000504
    DB_SYNC_DCB = 0x06800504
    DB_REQ_VACUUM_DBC = 0x06000505
    DB_VACUUM_DCB = 0x06800505
    DB_REQ_SYNC_BPU_CONF = 0x06000506
    DB_SYNC_BPU_CONF = 0x06800506
    DB_REQ_VACUUM_BPU_CONF = 0x06000507
    DB_VACUUM_BPU_CONF = 0x06800507
    DB_REQ_SYNC_DCB_CONF = 0x06000508
    DB_SYNC_DCB_CONF = 0x06800508
    DB_REQ_VACUUM_DBC_CONF = 0x06000509
    DB_VACUUM_DCB_CONF = 0x06800509
    DB_REQ_SYNC_WALLBOX = 0x0600050A
    DB_SYNC_WALLBOX = 0x0680050A
    DB_REQ_VACUUM_WALLBOX = 0x0600050B
    DB_VACUUM_WALLBOX = 0x0680050B
    DB_REQ_SYNC_PV_DEBUG = 0x0600050C
    DB_SYNC_PV_DEBUG = 0x0680050C
    DB_REQ_VACUUM_PV_DEBUG = 0x0600050D
    DB_VACUUM_PV_DEBUG = 0x0680050D
    DB_REQ_SYNC_CONFIG = 0x0600050E
    DB_SYNC_CONFIG = 0x0680050E
    DB_REQ_VACUUM_CONFIG = 0x0600050F
    DB_VACUUM_CONFIG = 0x0680050F
    DB_REQ_SET_SYNC_TIME = 0x06000510
    DB_SET_SYNC_TIME = 0x06800510

    DB_PAR_TIME_MIN = 0x06B00000
    DB_PAR_TIME_MAX = 0x06B00001
    DB_PARAM_ROW = 0x06B00002
    DB_PARAM_COLUMN = 0x06B00003
    DB_PARAM_INDEX = 0x06B00004
    DB_PARAM_VALUE = 0x06B00005
    DB_PARAM_MAX_ROWS = 0x06B00006
    DB_PARAM_TIME = 0x06B00007
    DB_PARAM_VERSION = 0x06B00008
    DB_PARAM_HEADER = 0x06B00009

    SYS_REQ_SYSTEM_REBOOT = 0x0C000001
    SYS_SYSTEM_REBOOT = 0x0C800001
    SYS_REQ_IS_SYSTEM_REBOOTING = 0x0C000002
    SYS_IS_SYSTEM_REBOOTING = 0x0C800002
    SYS_REQ_RESTART_APPLICATION = 0x0C000003
    SYS_RESTART_APPLICATION = 0x0C800003
    SYS_REQ_SCRIPT_FILE_LIST = 0x0C000010
    SYS_SCRIPT_FILE_LIST = 0x0C800010
    SYS_SCRIPT_FILE = 0x0C800011
    SYS_REQ_EXECUTE_SCRIPT = 0x0C000015
    SYS_EXECUTE_SCRIPT = 0x0C800015

    SYS_GENERAL_ERROR = 0x0CFFFFFF

    UM_REQ_UPDATE_STATUS = 0x0D000001
    UM_UPDATE_STATUS = 0x0D800001
    UM_REQ_UPDATE_DCDC = 0x0D000002
    UM_UPDATE_DCDC = 0x0D800002
    UM_REQ_CHECK_FOR_UPDATES = 0x0D000003
    UM_CHECK_FOR_UPDATES = 0x0D800003

    UM_GENERAL_ERROR = 0x0DFFFFFF

    WB_REQ_DATA = 0x0E040000
    WB_INDEX = 0x0E040001
    WB_DATA = 0x0E840000
    WB_REQ_ENERGY_ALL = 0x0E000001
    WB_REQ_ENERGY_SOLAR = 0x0E000002
    WB_REQ_SOC = 0x0E000003
    WB_REQ_STATUS = 0x0E000004
    WB_REQ_ERROR_CODE = 0x0E000005
    WB_REQ_MODE = 0x0E000006
    WB_REQ_APP_SOFTWARE = 0x0E000007
    WB_REQ_BOOTLOADER_SOFTWARE = 0x0E000008
    WB_REQ_HW_VERSION = 0x0E000009
    WB_REQ_FLASH_VERSION = 0x0E00000A
    WB_REQ_DEVICE_ID = 0x0E00000B
    WB_REQ_DEVICE_STATE = 0x0E060000
    WB_REQ_PM_POWER_L1 = 0x0E00000C
    WB_REQ_PM_POWER_L2 = 0x0E00000D
    WB_REQ_PM_POWER_L3 = 0x0E00000E
    WB_REQ_PM_ACTIVE_PHASES = 0x0E00000F
    WB_REQ_PM_MODE = 0x0E000011
    WB_REQ_PM_ENERGY_L1 = 0x0E000012
    WB_REQ_PM_ENERGY_L2 = 0x0E000013
    WB_REQ_PM_ENERGY_L3 = 0x0E000014
    WB_REQ_PM_DEVICE_ID = 0x0E000015
    WB_REQ_PM_ERROR_CODE = 0x0E000016
    WB_REQ_PM_DEVICE_STATE = 0x0E000029
    WB_REQ_PM_FIRMWARE_VERSION = 0x0E000017

    WB_REQ_DIAG_DEVICE_ID = 0x0E000018
    WB_REQ_DIAG_BAT_CAPACITY = 0x0E000019
    WB_REQ_DIAG_USER_PARAM = 0x0E00001A
    WB_REQ_DIAG_MAX_CURRENT = 0x0E00001B
    WB_REQ_DIAG_PHASE_VOLTAGE = 0x0E00001C
    WB_REQ_DIAG_DISPLAY_SPEECH = 0x0E00001D
    WB_REQ_DIAG_DESIGN = 0x0E00001E
    WB_REQ_DIAG_INFOS = 0x0E00001F
    WB_REQ_DIAG_WARNINGS = 0x0E000020
    WB_REQ_DIAG_ERRORS = 0x0E000021
    WB_REQ_DIAG_TEMP_1 = 0x0E000022
    WB_REQ_DIAG_TEMP_2 = 0x0E000023
    WB_REQ_DIAG_CP_PEGEL = 0x0E000024
    WB_REQ_DIAG_PP_IN_A = 0x0E000025
    WB_REQ_DIAG_STATUS_DIODE = 0x0E000026
    WB_REQ_DIAG_DIG_IN_1 = 0x0E000027
    WB_REQ_DIAG_DIG_IN_2 = 0x0E000028

    WB_ENERGY_ALL = 0x0E800001
    WB_ENERGY_SOLAR = 0x0E800002
    WB_SOC = 0x0E800003
    WB_STATUS = 0x0E800004
    WB_ERROR_CODE = 0x0E800005
    WB_MODE = 0x0E800006
    WB_APP_SOFTWARE = 0x0E800007
    WB_BOOTLOADER_SOFTWARE = 0x0E800008
    WB_HW_VERSION = 0x0E800009
    WB_FLASH_VERSION = 0x0E80000A
    WB_DEVICE_ID = 0x0E80000B

    WB_DEVICE_STATE = 0x0E860000
    WB_DEVICE_CONNECTED = 0x0E860001
    WB_DEVICE_WORKING = 0x0E860002
    WB_DEVICE_IN_SERVICE = 0x0E860003
    WB_GENERAL_ERROR = 0x0EFFFFFF

    WB_PM_POWER_L1 = 0x0E80000C
    WB_PM_POWER_L2 = 0x0E80000D
    WB_PM_POWER_L3 = 0x0E80000E
    WB_PM_ACTIVE_PHASES = 0x0E80000F
    WB_PM_MODE = 0x0E800011
    WB_PM_ENERGY_L1 = 0x0E800012
    WB_PM_ENERGY_L2 = 0x0E800013
    WB_PM_ENERGY_L3 = 0x0E800014
    WB_PM_DEVICE_ID = 0x0E800015
    WB_PM_ERROR_CODE = 0x0E800016
    WB_PM_DEVICE_STATE = 0x0E800029
    WB_PM_DEVICE_STATE_CONNECTED = 0x0E800030
    WB_PM_DEVICE_STATE_WORKING = 0x0E800031
    WB_PM_DEVICE_STATE_IN_SERVICE = 0x0E800032
    WB_PM_FIRMWARE_VERSION = 0x0E800017

    WB_DIAG_DEVICE_ID = 0x0E800018
    WB_DIAG_BAT_CAPACITY = 0x0E800019
    WB_DIAG_USER_PARAM = 0x0E80001A
    WB_DIAG_MAX_CURRENT = 0x0E80001B
    WB_DIAG_PHASE_VOLTAGE = 0x0E80001C
    WB_DIAG_DISPLAY_SPEECH = 0x0E80001D
    WB_DIAG_DESIGN = 0x0E80001E
    WB_DIAG_INFOS = 0x0E80001F
    WB_DIAG_WARNINGS = 0x0E800020
    WB_DIAG_ERRORS = 0x0E800021
    WB_DIAG_TEMP_1 = 0x0E800022
    WB_DIAG_TEMP_2 = 0x0E800023
    WB_DIAG_CP_PEGEL = 0x0E800024
    WB_DIAG_PP_IN_A = 0x0E800025
    WB_DIAG_STATUS_DIODE = 0x0E800026
    WB_DIAG_DIG_IN_1 = 0x0E800027
    WB_DIAG_DIG_IN_2 = 0x0E800028

    WB_REQ_AVAILABLE_SOLAR_POWER = 0x0E041000
    WB_POWER = 0x0E041001
    WB_STATUS_BIT = 0x0E041002
    WB_AVAILABLE_SOLAR_POWER = 0x0E841000
    WB_REQ_SET_MODE = 0x0E000030
    WB_MODE_PARAM_MODE = 0x0E040031
    WB_MODE_PARAM_MAX_CURRENT = 0x0E040032
    WB_SET_MODE = 0x0E000031

    WB_REQ_SET_EXTERN = 0x0E041010
    WB_SET_EXTERN = 0x0E841010
    WB_EXTERN_DATA = 0x0E042010
    WB_EXTERN_DATA_LEN = 0x0E042011

    WB_REQ_EXTERN_DATA_SUN = 0x0E041011
    WB_REQ_EXTERN_DATA_NET = 0x0E041012
    WB_REQ_EXTERN_DATA_ALL = 0x0E041013
    WB_REQ_EXTERN_DATA_ALG = 0x0E041014

    WB_EXTERN_DATA_SUN = 0x0E841011
    WB_EXTERN_DATA_NET = 0x0E841012
    WB_EXTERN_DATA_ALL = 0x0E841013
    WB_EXTERN_DATA_ALG = 0x0E841014

    WB_REQ_SET_BAT_CAPACITY = 0x0E041015
    WB_REQ_SET_ENERGY_ALL = 0x0E041016
    WB_REQ_SET_ENERGY_SOLAR = 0x0E041017
    WB_REQ_SET_PARAM_1 = 0x0E041018
    WB_REQ_SET_PARAM_2 = 0x0E041019
    WB_REQ_SET_PW = 0x0E041020
    WB_PARAM_USR = 0x0E042012
    WB_PARAM_PW = 0x0E042013

    WB_SET_BAT_CAPACITY = 0x0E841015
    WB_SET_ENERGY_ALL = 0x0E841016
    WB_SET_ENERGY_SOLAR = 0x0E841017
    WB_SET_PARAM_1 = 0x0E841018
    WB_SET_PARAM_2 = 0x0E841019
    WB_SET_PW = 0x0E841020
    WB_REQ_PARAM_2 = 0x0E04101A
    WB_RSP_PARAM_2 = 0x0E84101A
    WB_REQ_PARAM_1 = 0x0E04101B
    WB_RSP_PARAM_1 = 0x0E84101B
